//This code is writed by Nikos Mourgis. (nikosmourgis@gmail.com)
//The following code is writed with the convenience in mind and not
//for efficiency. The code may contains bugs that was unniticed while testing.
//use it freely at your convinience but please do not sell this code , and please
//do not remove this header. Last Update : 03/01/2018 

#ifndef UNICODE
#define UNICODE
#endif

#ifndef WINDOWS
#define WINDOWS 
#include<windows.h>
#endif


#ifndef STRINGR
#define STRINGR
#include<StringR.h>
#endif

WCHAR *IntToStr(long value);//convert a signet number to a string
WCHAR *LongToStr(unsigned long value);//convert a non signed number to a string
WCHAR *DecToHex(unsigned long value);
WCHAR *DecToHex(long value);
WCHAR *FloatToStr(long double value, short dig);
long StrToInt(WCHAR * num);
ULONG StrToLong(WCHAR * num);
double StrToFloat(WCHAR * num,WCHAR fc);
char *ConvertUTF8ToAnsi(const WCHAR *string);
WCHAR *ConvertAnsiToUTF8(const char *string);
WCHAR *ConvertUTF8CharToPercEsc(WCHAR thec) ;// takes a unicode code point and returns an percent escaped hex like %FF%FF.
                                             //returns NULL  if the character is in the ASCII table . IT DOES NOT SUPPORTS UNICODE CHARACTERS OF 3 BYTES (U+10000 to U+10FFFF)



//code


WCHAR *IntToStr(long value)
{
WCHAR *val=new WCHAR [33];

    ZeroMemory(val,33*2);

    if (value==0)
    {
        val[0]=48;
        return val;
    }

    WCHAR m;
    bool neg=false;

    int i=0;
    while (value!=0)
    {
        if (value<0)
        {
            value=value*(-1);
            neg=true;
        }

        m=value%10;
        value=value/10;
        switch (m)
        {
        case 0:val[i]=48;
            break;
        case 1:
            val[i]=49;
            break;
        case 2:
            val[i]=50;
            break;
        case 3:
            val[i]=51;
            break;
        case 4:
            val[i]=52;
            break;
        case 5:
            val[i]=53;
            break;
        case 6:
            val[i]=54;
            break;
        case 7:
            val[i]=55;
            break;
        case 8:
            val[i]=56;
            break;
        case 9:
            val[i]=57;
            break;
        }

        i++;
    }

    WCHAR *res=new WCHAR[33];

    ZeroMemory(res,33*2);

    int j=0;
    if (neg==true)
    {
        j++;
        res[0]='-';
    }
    for(int i=32;i>-1;i--)
    {
      if (val[i]>0)
      {
          res[j]=val[i];
          j++;
      }

    }

    delete [] val;

    return res;

}


WCHAR *LongToStr(unsigned long value)
{
    WCHAR *val=new WCHAR [33];

    ZeroMemory(val,33*2);

     if (value==0)
    {
        val[0]=48;
        return val;
    }

    WCHAR m;

    int i=0;
    while (value!=0)
    {

        m=value%10;
        value=value/10;
        switch (m)
        {
        case 0:val[i]=48;
            break;
        case 1:
            val[i]=49;
            break;
        case 2:
            val[i]=50;
            break;
        case 3:
            val[i]=51;
            break;
        case 4:
            val[i]=52;
            break;
        case 5:
            val[i]=53;
            break;
        case 6:
            val[i]=54;
            break;
        case 7:
            val[i]=55;
            break;
        case 8:
            val[i]=56;
            break;
        case 9:
            val[i]=57;
            break;
        }

        i++;
    }

    WCHAR *res=new WCHAR[33];

    ZeroMemory(res,33*2);

    int j=0;
    for(int i=32;i>-1;i--)
    {
      if (val[i]>0)
      {
          res[j]=val[i];
          j++;
      }

    }

    delete [] val;

    return res;
}

WCHAR *FloatToStr(long double value,short dig)
{

    if (dig>9)dig=9;
    if (dig<1) dig=1;

    long body=value;

    long double dek=(value-body);

    WCHAR * bdy=IntToStr(body);

    if (dek==0) return bdy;

    unsigned long temp=0;

    unsigned long digits=10;

    for (int i=1;i<dig;i++)
    digits*=10;


    dek=dek*digits;
    temp=dek;

    WCHAR * dekad=LongToStr(temp);

    WCHAR * res=new WCHAR[67];
    ZeroMemory(res,67);

    CopyMemory(res,bdy,StrLen(bdy));
    res[StrLen(bdy)]='.';
    CopyMemory(res+StrLen(bdy)+1,dekad,StrLen(dekad));

    delete [] bdy;
    delete [] dekad;

    return res;



}

WCHAR HexToChar(BYTE n)
{
    const WCHAR alpha[] = L"0123456789ABCDEF";

    if ( n > 15 ) return 0 ;

    return alpha[n];
}

    WCHAR *DecToHex(unsigned long value)
    {
        WCHAR temp[50];
        long indx=0;
        int mod;
        while (value!=0)
        {
         mod=value % 16;
         value=value / 16;
         temp[indx]=HexToChar(mod);
         indx++;
        }

        WCHAR *ret = new WCHAR[indx+1];
        temp[indx]=0;
        ret[indx]=0;
        ReverseString(temp,ret);
        return ret;

    };

    WCHAR *DecToHex(long value)
    {
        bool neg=false;
        WCHAR temp[50];
        long indx=0;
        int mod;
        if (value<0)
        {
          neg=true;
          indx++;
        };

        while (value!=0)
        {
         mod=value % 16;
         value=value / 16;
         temp[indx]=HexToChar(mod);
         indx++;
        }

        WCHAR *ret = new WCHAR[indx+1];
        temp[indx]=0;
        temp[0]='-';
        ret[indx]=0;
        ReverseString(temp,ret);
        return ret;

    };


long StrToInt(WCHAR * num)
{

     long ret=0;
    bool neg=false;
    int stop=0;
    int strl=StrLen(num);

    if (strl==0) return 0;

    if (num[0]=='-')
    {
        neg=true;
        stop=1;
    }

    

    int dekindex=1;

    for (int i=(strl-1);i>=stop;i--)
    {
        if ((num[i]>57)||(num[i]<48)) return 0;

        switch (num[i])
        {
            case 49:ret=ret+(1*dekindex);
            break;
            case 50:ret=ret+(2*dekindex);
            break;
            case 51:ret=ret+(3*dekindex);
            break;
            case 52:ret=ret+(4*dekindex);
            break;
            case 53:ret=ret+(5*dekindex);
            break;
            case 54:ret=ret+(6*dekindex);
            break;
            case 55:ret=ret+(7*dekindex);
            break;
            case 56:ret=ret+(8*dekindex);
            break;
            case 57:ret=ret+(9*dekindex);
            break;
        }

        dekindex=dekindex*10;
    }//for i

    if (neg) (ret=(-ret));

    return ret;

}


ULONG StrToLong(WCHAR* num)
{

    unsigned long ret=0;
    bool neg=false;
    int stop=0;
    int strl=StrLen(num);

    if (strl==0) return 0;

    if (num[0]=='-')
    {
        neg=true;
        stop=1;
    }

    int dekindex=1;

    for (int i=(strl-1);i>=stop;i--)
    {
        if ((num[i]>57)||(num[i]<48)) return 0;

        switch (num[i])
        {
            case 49:ret=ret+(1*dekindex);
            break;
            case 50:ret=ret+(2*dekindex);
            break;
            case 51:ret=ret+(3*dekindex);
            break;
            case 52:ret=ret+(4*dekindex);
            break;
            case 53:ret=ret+(5*dekindex);
            break;
            case 54:ret=ret+(6*dekindex);
            break;
            case 55:ret=ret+(7*dekindex);
            break;
            case 56:ret=ret+(8*dekindex);
            break;
            case 57:ret=ret+(9*dekindex);
            break;
        }//switch

        

        dekindex=dekindex*10;
    }//for i
    return ret;


}



double StrToFloat(WCHAR * num,WCHAR fc)
{
     if(num==NULL) return 0;

  

    unsigned long indx=0,temp=0;
    WCHAR *dekad;

    WCHAR *numi=ParamCopyStr(0,num,fc,false,indx);
   
    if (indx!=0)
    dekad=ParamCopyStr(indx,num,0,false,temp);
    else
    dekad=L"";

    double number=StrToInt(numi);
     double dek=0;
   if (dekad!=L"")
    dek=StrToInt(dekad);

    unsigned long pwr=10;

    int deklen=StrLen(dekad);


    for (int i=1;i<deklen;i++) pwr=pwr*10;

    dek=dek/pwr;

    number=number+dek;

    delete[] numi;

    if (dekad!=L"")
    delete[] dekad;

    return number;

}


WCHAR *ConvertAnsiToUTF8(const char *string)
 {

    ULONG slen;
    slen=StrLenA(string)+1;
    WCHAR *temp = new WCHAR [slen];
    ULONG tlen=slen;

    MultiByteToWideChar(CP_UTF8 , MB_ERR_INVALID_CHARS , string , -1 , temp , tlen );
    return temp;
 }

 char *ConvertUTF8ToAnsi(const WCHAR *string)
 {

    ULONG len=StrLen(string);
    char *tch=new char[len+1];
    WideCharToMultiByte(CP_ACP,0,string,len,tch,len,NULL,NULL);
    tch[len]=0;

    return tch;

 }

 WCHAR *ConvertUTF8CharToPercEsc(WCHAR thec)
 {
/*
1 	7 	U+0000 	U+007F 	0xxxxxxx
2 	11 	U+0080 	U+07FF 	110xxxxx 	10xxxxxx
3 	16 	U+0800 	U+FFFF 	1110xxxx 	10xxxxxx 	10xxxxxx
4 	21 	U+10000 	U+10FFFF 	11110xxx 	10xxxxxx 	10xxxxxx 	10xxxxxx
*/

if ( thec <= 0x007F )
{
    // this is a latin character no need for conversion, except is a reserved character.

    switch (thec)
    {
    case 0x21 :
        {
            WCHAR *ret = new WCHAR [4] ;
            CopyStr( ret , L"%21" , 4 );
            return ret ;
        }
    break;
    case 0x23 :
        {
            WCHAR *ret = new WCHAR [4] ;
            CopyStr( ret , L"%23" , 4 );
            return ret ;
        }
    break;
    case 0x24 :
        {
            WCHAR *ret = new WCHAR [4] ;
            CopyStr( ret , L"%24" , 4 );
            return ret ;
        }
    break;
    case 0x26 :
        {
            WCHAR *ret = new WCHAR [4] ;
            CopyStr( ret , L"%26" , 4 );
            return ret ;
        }
    break;
    case 0x27 :
        {
            WCHAR *ret = new WCHAR [4] ;
            CopyStr( ret , L"%27" , 4 );
            return ret ;
        }
    break;
    case 0x28 :
        {
            WCHAR *ret = new WCHAR [4] ;
            CopyStr( ret , L"%28" , 4 );
            return ret ;
        }
    break;
    case 0x29 :
        {
            WCHAR *ret = new WCHAR [4] ;
            CopyStr( ret , L"%29" , 4 );
            return ret ;
        }
    break;
    case 0x2A :
        {
            WCHAR *ret = new WCHAR [4] ;
            CopyStr( ret , L"%2A" , 4 );
            return ret ;
        }
    break;
    case 0x2B :
        {
            WCHAR *ret = new WCHAR [4] ;
            CopyStr( ret , L"%2B" , 4 );
            return ret ;
        }
    break;
    case 0x2C :
        {
            WCHAR *ret = new WCHAR [4] ;
            CopyStr( ret , L"%2C" , 4 );
            return ret ;
        }
    break;
    case 0x2F :
        {
            WCHAR *ret = new WCHAR [4] ;
            CopyStr( ret , L"%2F" , 4 );
            return ret ;
        }
    break;
    case 0x3A :
        {
            WCHAR *ret = new WCHAR [4] ;
            CopyStr( ret , L"%3A" , 4 );
            return ret ;
        }
    break;
    case 0x3B :
        {
            WCHAR *ret = new WCHAR [4] ;
            CopyStr( ret , L"%3B" , 4 );
            return ret ;
        }
    break;
    case 0x3D :
        {
            WCHAR *ret = new WCHAR [4] ;
            CopyStr( ret , L"%3D" , 4 );
            return ret ;
        }
    break;
    case 0x3F :
        {
            WCHAR *ret = new WCHAR [4] ;
            CopyStr( ret , L"%3F" , 4 );
            return ret ;
        }
    break;
    case 0x40 :
        {
            WCHAR *ret = new WCHAR [4] ;
            CopyStr( ret , L"%40" , 4 );
            return ret ;
        }
    break;
    case 0x5B :
        {
            WCHAR *ret = new WCHAR [4] ;
            CopyStr( ret , L"%5B" , 4 );
            return ret ;
        }
    break;
    case 0x5D :
        {
            WCHAR *ret = new WCHAR [4] ;
            CopyStr( ret , L"%5D" , 4 );
            return ret ;
        }
    break;

    default : return NULL ;
    }

}
else
    if ( thec <= 0x07FF )
{
    // this is a 2 bytes unicode character
    //now construct the right byte values

    // we isolate the bits of interest for the first byte ( see https://en.wikipedia.org/wiki/UTF-8 or (better) http://www.readytext.co.uk/?p=1284)
    // add the prefix of 110 and store it in the b1 ; We shift the bits to the rear to create a byte
     UCHAR b1 = (UCHAR) (((thec & 0x07C0) >> 6) | 0xC0  ); // first byte
    // do the same for the second byte
    UCHAR b2 =(UCHAR)((thec & 0x3F) | 0x80 ) ;

    WCHAR *fb = DecToHex((ULONG)b1);
    WCHAR *sb = DecToHex((ULONG)b2);

    WCHAR *efb = ConCat( L"%" , fb );
    WCHAR *esb = ConCat( L"%" , sb );

    WCHAR *ret = ConCat(efb,esb);

    delete [] fb ;
    delete [] sb ;
    delete [] efb ;
    delete [] esb ;

     return ret ;
}
else
    if( thec <= 0xFFFF )
{
    //this is a 2 bytes unicode character
    UCHAR b1 = (UCHAR) (((thec & 0xF0000) >> 12) | 0xE0  );
    UCHAR b2 = (UCHAR) (((thec & 0x0FC0) >> 6) | 0x080  );
    UCHAR b3 = (UCHAR) (((thec & 0x003F)) | 0x080  );

    WCHAR *fb = DecToHex((ULONG)b1);
    WCHAR *sb = DecToHex((ULONG)b2);
    WCHAR *tb = DecToHex((ULONG)b3);

    WCHAR *efb = ConCat( L"%" , fb );
    WCHAR *esb = ConCat( L"%" , sb );
    WCHAR *etb = ConCat( L"%" , tb );

    WCHAR *tmp = ConCat(efb,esb);
    WCHAR *ret = ConCat( tmp , etb );

    delete [] tmp ;
    delete [] fb ;
    delete [] sb ;
    delete [] tb ;
    delete [] efb ;
    delete [] esb ;
    delete [] etb ;

     return ret ;

}
 else
 {
     // this is a 4 bytes unicode character , not supported
     return NULL;
 }

 }








