//This code is writed by Nikos Mourgis. (nikosmourgis@gmail.com)
//The following code is writed with the convenience in mind and not
//for efficiency. The code may contains bugs that was unnoticed while testing.
//use it freely at your convinience but please do not sell this code , and please
//do not remove this header. Last Update : 03/01/2018 

#ifndef WINDOWS
#define WINDOWS 
#include <windows.h>
#endif

#ifndef WINPROC
#define WINPROC 
#include <WinProc.h>
#endif

#ifndef WSTRING
#define WSTRING
#include <wString.h>
#endif

#ifndef FILESTR
#define FILESTR 
#include "filestr.h"
#endif


struct PStringl
{
    PStringl *Left;
    wString String;
    PStringl *Right;
};

class StringList
{

private:

    PStringl *Curr,*First,*End;
    unsigned long Count;
    ULONG TextLength;
    bool OnAccess;
    void GoToBegin();
    void GoToEnd();
    void GoToPos(unsigned long Index);
    void Copy(wString S);
    void Concatenate(wString S);
    void Delete(const unsigned long Index);
public:
    void Add(wString S);
    void Add(WCHAR *S);
    void ClearList();
    void DeleteLine(const unsigned long indx);
    int IsInList(WCHAR * text);
    int IsInListQuick(WCHAR * text);
    int GetCount();
    WCHAR *GetText();
    bool WriteToFile(WCHAR *filename,bool ANSI);
    bool AppendToFile(WCHAR *filename,bool ANSI);
    bool LoadFile(WCHAR *filename , bool ANSI);
    ULONG RemoveEmptyLines();
    wString &operator [](unsigned long Index);
    StringList &operator =(StringList &S);
    StringList &operator +(StringList &S);

StringList();
~StringList();

};


//code


    void StringList::Copy(wString S)
{

Curr->String=S;

};

    void StringList::Concatenate(wString S)
{
    Curr->String=Curr->String+S;
};

    void StringList::Add(wString S)
{

    while(OnAccess==true){Sleep(1);};
    OnAccess=true;

    if (Count==0)
    {
      GoToBegin();
      Copy(S);
      Count++;

    }else
    {
    GoToEnd();
    PStringl *N=new PStringl;
    Curr->Right=N;
    N->Left=Curr;
    N->Right=NULL;
    N->String=S;
    Curr=N;
    Count++;
    End=Curr;
    }
    OnAccess=false;
};


  void StringList::Add(WCHAR *S)
{
    while(OnAccess==true)
    {
        Sleep(1);
    };
    OnAccess=true;

    if (Count==0)
    {
      GoToBegin();
      Curr->String=S;
      Count++;
    }else
    {

    GoToEnd();
    PStringl *N=new PStringl;
    Curr->Right=N;
    N->Left=Curr;
    N->Right=NULL;
    Curr=N;
    Curr->String=S;
    Count++;
    End=Curr;
    }
    OnAccess=false;
};

    void StringList::Delete(const unsigned long Index)
{
    GoToPos(Index);
    PStringl *del,*left,*right;
if (Curr!=NULL)
{
    if (Index==0)//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
{
GoToBegin();
if (Count!=1)
{
del=Curr;
GoToPos(Index+1);
    First=Curr;
Curr->Left=NULL;

Count--;
GoToBegin();
del->String.wFree();
del->String.~wString();
delete del;
}//if count!=1
else
{
  GoToBegin();
Count--;
}
}

else
if ((Index+1)<Count)//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
{
del=Curr;
GoToPos(Index-1);
left=Curr;
GoToPos(Index+1);
right=Curr;
left->Right=right;
right->Left=left;

del->String.~wString();
delete del;
Count--;
//Current=Index+1;//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    GoToBegin();
}//if <Count
else

if ((Index+1)==Count)//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
{

if (Count!=1)
{
del=Curr;
GoToPos(Index-1);
left=Curr;

left->Right=NULL;
del->String.wFree();
del->String.~wString();
delete del;
End=left;
Count--;
    GoToBegin();
}
}//if ==Count

}//if NULL

};

void StringList::DeleteLine(const unsigned long indx)
{
 while(OnAccess==true){Sleep(1);};
 OnAccess=true;
 Delete(indx);
 OnAccess=false;

}

int StringList::IsInList(WCHAR * text)
{
     int ret=-1;

     while(OnAccess==true){Sleep(1);};
     OnAccess=true;

     PStringl *temp=Curr;
     GoToBegin();
    for (ULONG i=0;i<Count;i++)
        {

            if (CompareText(text,Curr->String.Str())==0)
            {
                ret=i;
                break;
            }

             if (Curr->Right!=NULL)
            {
                Curr=Curr->Right;
            }
        }
     Curr=temp;
     OnAccess=false;
     return ret;
}

int StringList::IsInListQuick(WCHAR * text)
{
     int ret=-1;
     while (OnAccess==true){Sleep(1);};
     OnAccess=true;
     PStringl *en=End;
     if (Curr==NULL) return false;

     int teindx = 0;

   while (true)
        {
           try
           {
                if (CompareText(text,en->String.Str())==0)
                {
                    ret=teindx;
                    break;
                }

                 if (en->Left!=NULL)
                {
                    en=en->Left;
                } else
                {
                 OnAccess=false;
                 return ret;
                }
                teindx++;
           }  catch(...)
                           {
                               OnAccess=false;
                               return false;
                           }

        }
    OnAccess=false;
     return ret;
}

void StringList::ClearList()
{
    OnAccess=true;
    unsigned int C=Count+1;
  for (unsigned int i=1;i<C;i++)
    Delete(0);

   OnAccess=false;
};

int StringList::GetCount()
{
return Count;

};



 WCHAR *StringList::GetText()
 {
      while(OnAccess==true){Sleep(1);};
      OnAccess=true;

      ULONG len=0;
      WCHAR *Text=NULL;
      PStringl *current=NULL;
      ULONG indx=0;
      ULONG slen=0;
      current=First;
      if (Count>0)
      {
      for(ULONG i=1;i<=Count;i++)
      {
       len=len+current->String.GetLength()+2;//+2 cr+lf
       current=current->Right;
       }

       current=First;
       TextLength=len-2;
       Text=new WCHAR[len];
       ZeroMemory(Text,len*2);
       for(ULONG i=1;i<=Count;i++)
       {
           slen=current->String.GetLength();
           for (ULONG j=0;j<slen;j++)
           {
               Text[indx]=current->String[j];
               indx++;
           }
           Text[indx]=0x000D;
           indx++;
           Text[indx]=0x000A;
           indx++;


           current=current->Right;
       }

        Text[len-2]=0;  
        OnAccess=false;                     
        return Text;
       }
      OnAccess=false;
      return NULL;
 }


 bool StringList::WriteToFile(WCHAR *filename,bool ANSI)
 {
     if (ANSI==false)
     {

      while(OnAccess==true){Sleep(1);};
      bool ret=false;
      HANDLE f;
      WCHAR *txt;
      txt=GetText();
      if (txt!=NULL)
      {
          f=Open_File(filename,WR,0,true);
          LARGE_INTEGER li;
          li.QuadPart=0;
          Move_Pointer(f,li, FILE_BEGIN); 
          SetEndOfFile(f);
          unsigned long tlen=TextLength*2;
          ret=Write_File(f,(char*)txt,tlen);
          delete [] txt;
          CloseHandle(f);
      }

      OnAccess=false;
      return ret;

     } else
            {

                  while(OnAccess==true){Sleep(1);};
                  bool ret=false;
                  HANDLE f;
                  WCHAR *txt;
                  txt=GetText();
                  wString temp;
                  temp=txt;
                  if (txt!=NULL)
                  {
                      f=Open_File(filename,WR,0,true);
                      LARGE_INTEGER li;
                      li.QuadPart=0;
                      Move_Pointer(f,li, FILE_BEGIN);
                      SetEndOfFile(f);
                      unsigned long tlen=(unsigned long)temp.GetLength();
                      ret=Write_File(f,temp.Stra(),tlen);
                      delete [] txt;
                      temp.~wString();
                      CloseHandle(f);
                  }

                  OnAccess=false;
                  return ret;


            }


 }

 bool StringList::AppendToFile(WCHAR *filename,bool ANSI)
 {
     if (ANSI==false)
     {

      while(OnAccess==true){Sleep(1);};
      bool ret=false;
      HANDLE f;
      WCHAR *txt;
      ULONG tmp=1;

      txt=GetText();
      if (txt!=NULL)
      {

          f=Open_File(filename,WR,0,true);
          LARGE_INTEGER li;
          li.QuadPart=0;
          if (Move_Pointer(f,li, FILE_END)==false)
          {
               CloseHandle(f);
               return false;
          }
          WCHAR crlf[2];
          crlf[0]=0x000D;
          crlf[1]=0x000A;

          tmp=2*2;
          Write_File(f,(char*)crlf,tmp);
          unsigned long tlen=TextLength*2;
          ret=Write_File(f,(char *)txt,tlen);
          delete [] txt;
          CloseHandle(f);
      }
      OnAccess=false;
      return ret;
     }

      else
        {

             while(OnAccess==true){Sleep(1);};
              bool ret;
              HANDLE f;
              WCHAR *txt;
              ULONG tmp=1;

              txt=GetText();
              wString temp;
              temp=txt;
              if (txt!=NULL)
              {

                  f=Open_File(filename,WR,0,true);
                  LARGE_INTEGER li;
                  li.QuadPart=0;
                  if (Move_Pointer(f,li, FILE_END)==false)
                  {
                       CloseHandle(f);
                       return false;
                  }
                  char crlf[2];
                  crlf[0]=0x0D;
                  crlf[1]=0x0A;

                  tmp=2;
                  Write_File(f,crlf,tmp);
                  unsigned long tlen=temp.GetLength();
                  ret=Write_File(f,temp.Stra(),tlen);
                  delete [] txt;
                  temp.~wString();
                  CloseHandle(f);


                    }
                }

 }

 bool StringList::LoadFile(WCHAR *filename , bool ANSI)
 {

     if (ANSI == false)
     {
        while(OnAccess==true){Sleep(1);};

        HANDLE f = Open_File(filename, RD , ShareRead , false);
        WCHAR *line ;
        ULONG br ;
        while (Read_FileTXTU( f , line , br ) == FERR_SUCCESS)
        {
            Add(line);
            delete [] line ;
        }

        CloseHandle(f) ;


     } else
     {
          while(OnAccess==true){Sleep(1);};

        HANDLE f = Open_File(filename, RD , ShareRead , false);
        char line[2048] ;
        ULONG br ;
        while (Read_FileTXTANSI( f , line , 2048 , br ) == FERR_SUCCESS)
        {
           WCHAR *l = ConvertAnsiToUTF8(line);
            Add(l);
            delete [] l ;
        }

        CloseHandle(f) ;
     }



 }



 ULONG StringList::RemoveEmptyLines()
 {

       bool IsEmty=true;
       ULONG EmtyCount=0;
       WCHAR c=0;
       ULONG indx=0;

    while(OnAccess==true){Sleep(1);};
    OnAccess=true;


       while (indx<Count)
       {
           GoToPos(indx);//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
           Curr->String.Str();

             for(int j=0;j<Curr->String.GetLength();j++)//   
             {
                 c=Curr->String[j];
                 if((c!=0x000D)&&(c!=0x000A)&&(c!=0x0009)&&(c!=L' '))
                 IsEmty=false;
                 break;

             }//for j

           if (IsEmty==true)
           {
               EmtyCount++;
               Delete(indx);
               indx--;
           }

           IsEmty=true;
           indx++;
       }//for i
     OnAccess=false;
     return EmtyCount;

 }



    void StringList::GoToBegin()
{
  Curr=First;
};


    void StringList::GoToEnd()
{
  Curr=End;
};

    void StringList::GoToPos(unsigned long Index)
        {
        try
        {
        if (Index<0) throw -1;
        else
        if (Index>(Count-1)) throw -2;
         GoToBegin();
        // Current=0;
                if ((Count>1)&&(Index>0))
                {
                    for (unsigned long i=1;i<Index+1;i++)//+++++++++++++++++++++++++++++++++++++++++++
                    {

                        if (Curr->Right!=NULL)
                        {
                            Curr=Curr->Right;
              //          Current++;
                        }
                    }
                }
//            SetLength();
            }//try

            catch(...)
            {
               Smessage(L"StringList Index Error At:",IntToStr(Index));
            }
        };
 wString &StringList::operator [](unsigned long Index)
{
    while(OnAccess==true){Sleep(1);};
    OnAccess=true;
    GoToPos(Index);
    OnAccess=false;
    return Curr->String;

};


    StringList &StringList::operator =(StringList &S)
{
     while(OnAccess==true){Sleep(1);};
    OnAccess=true;

    ClearList();
  for(int i=1;i<=S.GetCount();i++)
  Add(S[i]);

  OnAccess=false;
 return *this;
};

    StringList &StringList::operator +(StringList &S)
{
    while(OnAccess==true){Sleep(1);};
    OnAccess=true;

     for(int i=1;i<=S.GetCount();i++)
     Add(S[i]);

    OnAccess=false;
    return *this;
};


StringList::StringList()
{
   Curr=new PStringl;
   Curr->Left=NULL;
   Curr->Right=NULL;
    First=Curr;
    End=Curr;
   Count=0;
   OnAccess=false;
//   Current=0;
   TextLength=0;
//   SetLength();
};


StringList::~StringList()
{
    if (First!=NULL)
    {
    unsigned int C=Count+1;
    for (unsigned int i=1;i<C;i++)
    Delete(0);
    GoToBegin();
    Curr->String.wFree();
    Curr->String.~wString();
    delete Curr;
    First=NULL;
  }

};






